//
//  Downloader.h
//  Downloader
//
//  Created by yy030913 on 11/23/17.
//  Copyright © 2017 yy030913. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef void (^DownloadCompleteCallback)(NSNumber*, NSNumber*);
typedef void (^ErrorCallback)(NSError*);
typedef void (^BeginCallback)(NSNumber*, NSNumber*, NSDictionary*);
typedef void (^ProgressCallback)(NSNumber*, NSNumber*);
typedef void (^ResumableCallback)();

@interface RNINAPPDownloadParams : NSObject

@property (copy) NSString* fromUrl;
@property (copy) NSString* toFile;
@property (copy) NSDictionary* headers;
@property (copy) DownloadCompleteCallback completeCallback;   // Download has finished (data written)
@property (copy) ErrorCallback errorCallback;                 // Something went wrong
@property (copy) BeginCallback beginCallback;                 // Download has started (headers received)
@property (copy) ProgressCallback progressCallback;           // Download is progressing
@property (copy) ResumableCallback resumableCallback;         // Download has stopped but is resumable
@property (copy) NSNumber* progressDivider;
@property (copy) NSNumber* readTimeout;
@property (copy) NSNumber* connectionTimeout;
/*成员变量必须包含在大括号中
*注意成员变量不声明任何关键字的话是@Protected，其他还有@Private和@Public
*注意在ObjC中不管是自定义的类还是系统类对象都必须是一个指针，例如下面的fromUrl
*/

@end

@interface RNINAPPDownloader : NSObject <NSURLSessionDelegate, NSURLSessionDownloadDelegate>
//声明一个动态方法，返回NSString类型
- (NSString *)downloadFile:(RNINAPPDownloadParams*)params;
- (void)stopDownload;
- (void)resumeDownload;
- (BOOL)isResumable;

@end
